! -*- Fortran -*-
!                    University of Illinois/NCSA
!                        Open Source License
!
!          Copyright (C) 2002-2006, The Board of Trustees of
!          The University of Illinois. All rights reserved.
! 
!                           Developed by:             
! 
!                       The PerfSuite Project
!           National Center for Supercomputing Applications
!             University of Illinois at Urbana-Champaign
!
!                  http://perfsuite.ncsa.uiuc.edu/
!
! Permission is hereby granted, free of charge, to any person obtaining
! a copy of this software and associated documentation files (the "Software"),
! to deal with the Software without restriction, including without limitation
! the rights to use, copy, modify, merge, publish, distribute, sublicense, 
! and/or sell copies of the Software, and to permit persons to whom the 
! Software is furnished to do so, subject to the following conditions:
!
! + Redistributions of source code must retain the above copyright notice, 
!   this list of conditions and the following disclaimers.
! + Redistributions in binary form must reproduce the above copyright
!   notice, this list of conditions and the following disclaimers in
!   the documentation and/or other materials provided with the distribution.
! + Neither the names of The PerfSuite Project, NCSA/University of Illinois
!   at Urbana-Champaign, nor the names of its contributors may be used to
!   endorse or promote products derived from this Software without specific
!   prior written permission.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
! OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
! CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
! FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS WITH THE SOFTWARE.
!
! $Id: fperfsuite.h,v 1.26 2006/01/16 21:15:02 rkufrin Exp $ 

! Definitions for PSF_procstat

      integer PS_PID, PS_PPID, PS_PGRP, PS_SESSION, PS_TTY
      integer PS_TPGID, PS_FLAGS, PS_MINFLT, PS_CMINFLT, PS_MAJFLT
      integer PS_CMAJFLT, PS_UTIME, PS_STIME, PS_CUTIME, PS_CSTIME
      integer PS_PRIORITY, PS_NICE, PS_NUMTHREADS, PS_ITREALVALUE
      integer PS_STARTTIME, PS_VSIZE, PS_RSS, PS_RLIM, PS_STARTCODE
      integer PS_ENDCODE, PS_STARTSTACK, PS_KSTKESP, PS_KSTKEIP
      integer PS_SIGNAL, PS_BLOCKED, PS_SIGIGNORE, PS_SIGCATCH
      integer PS_WCHAN, PS_NSWAP, PS_CNSWAP, PS_EXITSIGNAL
      integer PS_PROCESSOR

      parameter (PS_PID=1, PS_PPID=2, PS_PGRP=3, PS_SESSION=4)
      parameter (PS_TTY=5, PS_TPGID=6, PS_FLAGS=7, PS_MINFLT=8)
      parameter (PS_CMINFLT=9, PS_MAJFLT=10, PS_CMAJFLT=11, PS_UTIME=12)
      parameter (PS_STIME=13, PS_CUTIME=14, PS_CSTIME=15)
      parameter (PS_PRIORITY=16, PS_NICE=17, PS_NUMTHREADS=18)
      parameter (PS_ITREALVALUE=19, PS_STARTTIME=20, PS_VSIZE=21)
      parameter (PS_RSS=22, PS_RLIM=23, PS_STARTCODE=24)
      parameter (PS_ENDCODE=25, PS_STARTSTACK=26, PS_KSTKESP=27)
      parameter (PS_KSTKEIP=28, PS_SIGNAL=29, PS_BLOCKED=30)
      parameter (PS_SIGIGNORE=31, PS_SIGCATCH=32, PS_WCHAN=33)
      parameter (PS_NSWAP=34, PS_CNSWAP=35, PS_EXITSIGNAL=36)
      parameter (PS_PROCESSOR=37)

      integer PS_PROCSTATSIZE, PS_MAXCOMMSIZ
      parameter (PS_PROCSTATSIZE=37, PS_MAXCOMMSIZ=15)

! Error code parameters

      integer PS_MINERRNO, PS_MAXERRNO, PS_MAXERRLEN
      parameter (PS_MINERRNO=-2, PS_MAXERRNO=1013, PS_MAXERRLEN=64)

! Error codes from libperfsuite

      integer PS_SUCCESS, PS_ENOMEM, PS_ESYS, PS_ECPUNOTSUPPORTED
      integer PS_EUNKNOWNCPU, PS_ENOTFOUND, PS_ENOTINSTALLED
      integer PS_EBADXMLDOCTYPE, PS_ENOTIMPLEMENTED, PS_EBUFFER

      parameter (PS_SUCCESS=0, PS_ENOMEM=-2, PS_ESYS=-1)
      parameter (PS_ECPUNOTSUPPORTED=1, PS_EUNKNOWNCPU=2)
      parameter (PS_ENOTFOUND=3, PS_ENOTINSTALLED=4)
      parameter (PS_EBADXMLDOCTYPE=5, PS_ENOTIMPLEMENTED=6)
      parameter (PS_EBUFFER=7)

! Error codes from libpshwpc

      integer PS_HWPC_EXMLPARSE, PS_HWPC_EEVENTSEXCEEDED
      integer PS_HWPC_EEVENTNOTSUPPORTED, PS_HWPC_EBADCLASS
      integer PS_HWPC_ESTREAM, PS_HWPC_EPERF, PS_HWPC_EBADEVENT
      integer PS_HWPC_ENOSUCHEVENT, PS_HWPC_EEVENTNOTAVAILABLE
      integer PS_HWPC_ENOTSUPPORTED, PS_HWPC_ENOSUCHXMLDOC
      integer PS_HWPC_ESEQUENCE, PS_HWPC_EMODE

      parameter (PS_HWPC_EXMLPARSE=1001,PS_HWPC_EEVENTSEXCEEDED=1002)
      parameter (PS_HWPC_EEVENTNOTSUPPORTED=1003)
      parameter (PS_HWPC_EBADCLASS=1004)
      parameter (PS_HWPC_ESTREAM=1005, PS_HWPC_EPERF=1006)
      parameter (PS_HWPC_EBADEVENT=1007, PS_HWPC_ENOSUCHEVENT=1008)
      parameter (PS_HWPC_EEVENTNOTAVAILABLE=1009)
      parameter (PS_HWPC_ENOTSUPPORTED=1010, PS_HWPC_ENOSUCHXMLDOC=1011)
      parameter (PS_HWPC_ESEQUENCE=1012, PS_HWPC_EMODE=1013)
