/* $Id: perfsuite.h,v 1.39 2008/11/26 20:28:22 rkufrin Exp $ */

/****************************************************************************
 *                    University of Illinois/NCSA
 *                        Open Source License
 * 
 *        Copyright(C) 2002-2006, The Board of Trustees of the
 *            University of Illinois. All rights reserved.
 * 
 *                            Developed by:             
 * 
 *                        The PerfSuite Project
 *           National Center for Supercomputing Applications
 *             University of Illinois at Urbana-Champaign
 * 
 *                  http://perfsuite.ncsa.uiuc.edu/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * + Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimers.
 * + Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in
 *   the documentation and/or other materials provided with the distribution.
 * + Neither the names of The PerfSuite Project, NCSA/University of Illinois
 *   at Urbana-Champaign, nor the names of its contributors may be used to
 *   endorse or promote products derived from this Software without specific
 *   prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS WITH THE SOFTWARE.
 ****************************************************************************/

#ifndef PERFSUITE_H_INCLUDED
#define PERFSUITE_H_INCLUDED 1

#undef BEGIN_C_DECLS
#undef END_C_DECLS
#ifdef __cplusplus
# define BEGIN_C_DECLS extern "C" {
# define END_C_DECLS }
#else
# define BEGIN_C_DECLS
# define END_C_DECLS
#endif

#undef PARAMS
#if defined (__STDC__) || defined(_AIX) \
        || (defined(__mips) && defined(_SYSTYPE_SVR4)) \
        || defined(WIN32) || defined(__cplusplus)
# define PARAMS(protos) protos
#else
# define PARAMS(protos) ()
#endif

#include <pstypes.h>
#include <pserror.h>

BEGIN_C_DECLS

/***************************************************************************
     Prototypes for all external routines contained in the core PerfSuite 
     library.  These should always be available regardless of the presence 
     of any other support libraries.
 ***************************************************************************/

extern int ps_cpuspeed         PARAMS((double *mhz));
extern int ps_cpuusage         PARAMS((pid_t pid,
                                       ps_time_t *utime, ps_time_t *stime));
extern int ps_dmemusage        PARAMS((float *total_mb, float *used_mb, 
                                       float *free_mb));
extern int ps_memusage         PARAMS((pid_t pid, float *vsize_mb,
                                       float *rss_mb));
extern int ps_procstat         PARAMS((pid_t pid, ps_procstat_t *p));
extern int ps_rtc              PARAMS((unsigned long long *rtcval));
extern int ps_rtcinit          PARAMS((void));
extern const char *ps_strerror PARAMS((int code));

END_C_DECLS

#endif
